Definition of a Delay Measurement Infrastructure and Delay-Sensitive Least-Used Policy for Reliable Server Pooling
Internet-Draft draft-dreibholz-rserpool-delay-29
Thomas Dreibholz
Simula Metropolitan Centre for Digital Engineering
Pilestredet 52
0167 Oslo
Norway
dreibh@simula.no
https://www.simula.no/people/dreibh
Xing Zhou
Hainan University, College of Information Science and Technology
Renmin Avenue 58
570228 Haikou
Hainan
China
+86-898-66279141
zhouxing@hainu.edu.cn
17 September 2022
Internet-Draft
This document contains the definition of a delay measurement infrastructure and a delay-sensitive Least-Used policy for Reliable Server Pooling.
Introduction
Reliable Server Pooling defines protocols for providing highly available services. PEs of a pool may be distributed over a large geographical area, in order to provide redundancy in case of localized disasters. But the current pool policies defined in [RFC5356] do not incorporate the fact of distances (i.e. delay) between PU and PE. This leads to a low performance for delay-sensitive applications.
Scope
This draft defines a delay measurement infrastructure for ENRP servers to add delay information into the handlespace. Furthermore, a delay-sensitive Least-Used policy is defined. Performance evaluations can be found in [KiVS2007].
Terminology
The terms are commonly identified in related work and can be found in the Aggregate Server Access Protocol and Endpoint Handlespace Redundancy Protocol Common Parameters document [RFC5354].
Conventions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119].
Delay-Measurement Infrastructure
This section describes the necessary delay measurement infrastructure for the policy later defined in Section 3. It has to be provided as part of the ENRP servers.
Quantification of Distance
Measuring delay for SCTP associations is easy: the SCTP protocol [RFC4960] already calculates a smoothed round-trip time (RTT) for the primary path. This RTT only has to be queried via the standard SCTP API as defined in [RFC6458]. By default, the calculated RTT has a small restriction: a SCTP endpoint waits up to 200ms before acknowledging a packet, in order to piggyback the acknowledgement chunk with payload data. In this case, the RTT would include this latency. By using the option SCTP_DELAYED_SACK (see [RFC6458]), the maximum delay before acknowledging a packet can be set to 0ms (i.e. "acknowledge as soon as possible"). After that, the RTT approximately consists of the network latency only. Then, using the RTT, the end-to-end delay between two associated components is approximately 0.5*RTT.
In real networks, there may be negligible delay differences: for example, the delay between a PU and PE #1 is 5ms and the latency between the PU and PE #2 is 6ms. From the service user's perspective, such minor delay differences may be ignored and are furthermore unavoidable in Internet scenarios. Therefore, the distance parameter between two components A and B is defined as follows:
Distance = DistanceStep * round( (0.5*RTT) / DistanceStep )
That is, the distance parameter is defined as the nearest integer multiple of the constant DistanceStep for the measured delay (i.e. 0.5*RTT).
Distance Measurement Environment
In order to define a distance-aware policy, it is first necessary to define a basic rule: PEs and PUs choose "nearby" ENRP servers. Since the operation scope of RSerPool is restricted to a single organization, this condition can be met easily by appropriately locating ENRP servers.
- A Home ENRP server can measure the delay of the ASAP associations to its PE. As part of its ENRP updates to other ENRP servers, it can report this measured delay together with the PE information.
- A non-Home-ENRP server receiving such an update simply adds the delay of the ENRP association with the Home ENRP server to the PE's reported delay.
Now, each ENRP server can approximate the distance to every PE in the operation scope using the equation in Section 2.1.
Note, that delay changes are propagated to all ENRP servers upon PE re-registrations, i.e. the delay information (and the approximated distance) dynamically adapts to the state of the network.
Distance-Sensitive Least-Used Policy
In this section, a distance-sensitive Least Used policy is defined, based on the delay-measurement infrastructure introduced in Section 2.
Description
The Least Used with Distance Penalty Factor (LU-DPF) policy uses load information provided by the pool elements to select the lowest-loaded pool elements within the pool. If there are multiple elements having lowest load, the nearest PE should be chosen.
ENRP Server Considerations
The ENRP server SHOULD select at most the requested number of pool elements. Their load values SHOULD be the lowest possible ones within the pool and their distances also SHOULD be lowest. Each element MUST NOT be reported more than once to the pool user. If there is a choice of equal-loaded and equal-distanced pool elements, round robin selection SHOULD be made among these elements. The returned list of pool elements MUST be sorted by load value in ascending order (1st key) and distance in ascending order (2nd key).
Pool User Considerations
The pool user should try to use the pool elements returned from the list in the order returned by the ENRP server. A subsequent call for handle resolution may result in the same list. Therefore, it is RECOMMENDED for a pool user to request multiple entries in order to have a sufficient amount of feasible backup entries available.
Pool Member Selection Policy Parameter

0                   1                   2                   3
0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|     Parameter Type = 0x6     |         Length = 0x14          |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                  Policy Type = 0x40000010                     |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                            Load                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                          Load DPF                             |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                          Distance                             |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

- Load: Current load of the pool element.
- Load DPF: The LoadDPF setting of the PE.
- Distance: The approximated distance in milliseconds.
  - Between PE and Home ENRP server: The distance SHOULD be set to 0.
  - Between Non-Home ENRP server and Home ENRP server: The delay measured on the ASAP association between Home ENRP server and PE.
  - Between ENRP server and PU: The sums of the measured delays on the ASAP association and the ENRP association to the Home ENRP server.
Reference Implementation
The RSerPool reference implementation RSPLIB can be found at [RSerPool-Website]. It supports the functionalities defined by [RFC5351], [RFC5352], [RFC5353], [RFC5354] and [RFC5356] as well as the options [I-D.dreibholz-rserpool-asap-hropt], [I-D.dreibholz-rserpool-enrp-takeover] and of course the option defined by this document. An introduction to this implementation is provided in [Dre2006].
Testbed Platform
A large-scale and realistic Internet testbed platform with support for the multi-homing feature of the underlying SCTP protocol is NorNet. A description of NorNet is provided in [PAMS2013-NorNet], some further information can be found on the project website [NorNet-Website].
Security Considerations
Security considerations for RSerPool systems are described by [RFC5355].
IANA Considerations
This document does not require additional IANA actions beyond those already identified in the ENRP and ASAP protocol specifications.
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC4960]

Stream Control Transmission Protocol
R. Stewart, Ed.
September 2007
RFC 4960
DOI 10.17487/RFC4960
[RFC5351]

An Overview of Reliable Server Pooling Protocols
P. Lei
L. Ong
M. Tuexen
T. Dreibholz
September 2008
RFC 5351
DOI 10.17487/RFC5351
[RFC5352]

Aggregate Server Access Protocol (ASAP)
R. Stewart
Q. Xie
M. Stillman
M. Tuexen
September 2008
RFC 5352
DOI 10.17487/RFC5352
[RFC5353]

Endpoint Handlespace Redundancy Protocol (ENRP)
Q. Xie
R. Stewart
M. Stillman
M. Tuexen
A. Silverton
September 2008
RFC 5353
DOI 10.17487/RFC5353
[RFC5354]

Aggregate Server Access Protocol (ASAP) and Endpoint Handlespace Redundancy Protocol (ENRP) Parameters
R. Stewart
Q. Xie
M. Stillman
M. Tuexen
September 2008
RFC 5354
DOI 10.17487/RFC5354
[RFC5355]

Threats Introduced by Reliable Server Pooling (RSerPool) and Requirements for Security in Response to Threats
M. Stillman, Ed.
R. Gopal
E. Guttman
S. Sengodan
M. Holdrege
September 2008
RFC 5355
DOI 10.17487/RFC5355
[RFC5356]

Reliable Server Pooling Policies
T. Dreibholz
M. Tuexen
September 2008
RFC 5356
DOI 10.17487/RFC5356
[RFC6458]

Sockets API Extensions for the Stream Control Transmission Protocol (SCTP)
R. Stewart
M. Tuexen
K. Poon
P. Lei
V. Yasevich
December 2011
RFC 6458
DOI 10.17487/RFC6458
[I-D.dreibholz-rserpool-asap-hropt]

Handle Resolution Option for ASAP
Thomas Dreibholz
SimulaMet
6 September 2021
Internet-Draft draft-dreibholz-rserpool-asap-hropt-29
[I-D.dreibholz-rserpool-enrp-takeover]

Takeover Suggestion Flag for the ENRP Handle Update Message
Thomas Dreibholz
SimulaMet
Xing Zhou
Hainan University
6 September 2021
Internet-Draft draft-dreibholz-rserpool-enrp-takeover-26
Informative References
[Dre2006]

Reliable Server Pooling – Evaluation, Optimization and Extension of a Novel IETF Architecture
ThomasDreibholz
7 March 2007
[KiVS2007]

On Improving the Performance of Reliable Server Pooling Systems for Distance-Sensitive Distributed Applications
ThomasDreibholz
Erwin PaulRathgeb
28 February 2007
Proceedings of the 15.ITG/GI Fachtagung Kommunikation in Verteilten Systemen(KiVS) Pages 39-50, ISBN978-3-540-69962-0, DOI10.1007/978-3-540-69962-0_4
[PAMS2013-NorNet]

Design and Implementation of the NorNet Core Research Testbed for Multi-Homed Systems
ThomasDreibholz
Ernst GunnarGran
27 March 2013
Proceedings of the 3nd International Workshop on Protocols and Applications with Multi-Homing Support(PAMS) Pages 1094-1100, ISBN978-0-7695-4952-1, DOI10.1109/WAINA.2013.71
[RSerPool-Website]

Thomas Dreibholz's RSerPool Page
ThomasDreibholz
2022
[NorNet-Website]

NorNet – A Real-World, Large-Scale Multi-Homing Testbed
Thomas Dreibholz
2022